//============================================================================
//	apci31s.pas
//
//	aPCI-P31
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.11 Date 1999/08/23
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//============================================================================
unit apci31s;

interface

uses
	Windows, Messages, SysUtils, Forms, apci31w;

const
	szTitle = 'Sample';
	szP31		= 'aPCI-P31';

type
	TForm1 = class(TForm)
		procedure FormCreate(Sender: TObject);
	private
		procedure ResultMessage(szBuf: String);
		procedure ErrorMessage(wLogSlot: Word);
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

//============================================================================
//	۸т̊Jn
//============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
	wLogSlot:	Word;								// ޲̘_ۯĔԍi[
	Ri:				TAPCI31RESOURCE;		// ؿ
	dwDLLVer, dwDriverVer: DWord;
	dwSwVal:	DWord;							// ۰ذ̒l
	cbDat:		Byte;
	bResult:	Boolean;						// 
	szBuf:		String;
begin
	//-------------------------------------------------
	// apci31.dll ̎gp錾
	//-------------------------------------------------
	if Apci31wDllOpen() = False then begin
		ErrorMessage(APCI31_SLOT_AUTO);
		Exit;											// apci31.dll ۰ނɎs܂
	end;
	//-------------------------------------------------
	// ްޮݔԍ\
	// aPCI-P31 DLL,ײްްޮݔԍ擾
	//-------------------------------------------------
	if Apci31wGetVersion(dwDLLVer, dwDriverVer) = False then begin
		ErrorMessage(APCI31_SLOT_AUTO);
		Exit;
	end;

	szBuf := Format('GetVersion'#10 +
									'DLL Version'#09+ ': %08xH'#10 +
									'Driver Version'#09+ ': %08xH',
									[dwDLLVer, dwDriverVer]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// aPCI-P31̎gp錾
	//-------------------------------------------------
	wLogSlot := APCI31_SLOT_AUTO;					// gp޲T܂B
	bResult := Apci31wCreate(wLogSlot);		// ꍇA̎޲̘_ۯĔԍi[܂B
	if bResult = False then begin					// ޲܂B
		ErrorMessage(APCI31_SLOT_AUTO);
		Exit;
	end;
	szBuf := Format('aPCI-P31 Created'#10#10 +
									'LogSlot: %2d'
									,[wLogSlot]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// ؿ۰ذ̒l擾
	//-------------------------------------------------
	if Apci31wGetResource(wLogSlot, Ri) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	if Apci31wGetSwitchValue(wLogSlot, dwSwVal) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	szBuf := Format( 'Board Name'#09 + ': %s'#10 +
									 'IO Address'#09 + ': %04xH-%04xH'#10 +
									 'Switch    '#09 + ': %04xH',
									 [szP31,
										Ri.dwIOPortBase[1],
										Ri.dwIOPortBase[1] + Ri.dwIOPortLength[1] - 1,
										dwSwVal]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// Port 1 ɔCӂްo
	//-------------------------------------------------
	cbDat := Byte($AA);
	if Apci31wOutPort(wLogSlot, APCI31_PORT_1, cbDat) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	szBuf := Format( 'Port 1 փf[^o'#10 +
					 				 'Port 1 Out Data: %02xH',
									 [cbDat]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// Port 1 ްǂݍ
	//-------------------------------------------------
	cbDat := Byte($00);
	if Apci31wInPort(wLogSlot, APCI31_PORT_1, cbDat) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	szBuf := Format( 'Port 1 f[^'#10 +
									 'Port 1 In Data: %02xH',
									 [cbDat]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// aPCI-P31̎gpJ
	//-------------------------------------------------
	if Apci31wClose(wLogSlot) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	ResultMessage('aPCI-P31 Closed');
	//-------------------------------------------------
	// apci31.dll ̎gpJ
	//-------------------------------------------------
	if Apci31wDllClose() = False then begin
		Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
		Exit;
	end;
end;

//============================================================================
// ʂ\
//============================================================================
procedure TForm1.ResultMessage(szBuf: String);
begin
	Application.MessageBox(PChar(szBuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;
//============================================================================
// װүނ\
//============================================================================
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	szBuf: String;
begin
	dwRes := Apci31wGetLastError(wLogSlot);
	case dwRes of
		APCI31_ERR_SYSTEM:
			szBuf := Format('System error'#10#10'Error code: %08xH', [GetLastError()]);
		APCI31_ERR_WRAPDLL:
    	szBuf := 'DLL Load error';
		else
			szBuf := Format('aPCI-P31 error'#10#10'Error code: %08xH',[dwRes]);
  end;
	Application.MessageBox(PChar(szBuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.

