/*============================================================================
//	apci31s.c
//
//	aPCI-P31
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//==========================================================================*/
#define	STRICT
#include <windows.h>
#include <tchar.h>
#include "apci31w.h"

const TCHAR szTitle[] = _T("Sample");
const TCHAR szP31[]   = _T("aPCI-P31");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);

/*============================================================================
//	۸т̊Jn
//===========================================================================*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	WORD  wLogSlot;				/* ޲̘_ۯĔԍi[ */
	APCI31RESOURCE Ri;			/* ؿ */
	DWORD dwDLLVer, dwDriverVer;
	DWORD dwSwVal;				/* ۰ذ̒l */
	BYTE  cbDat;
	BOOL  bResult;				/*  */
	TCHAR szBuf[256];

	/*-------------------------------------------------
	// apci31.dll ̎gp錾
	//-----------------------------------------------*/
	if (Apci31wDllOpen() == FALSE){
		ErrorMessage(APCI31_SLOT_AUTO);
		return 1;				/* apci31.dll ۰ނɎs܂ */
	}
	/*-------------------------------------------------
	// ްޮݔԍ\
	// aPCI-P31 DLL,ײްްޮݔԍ擾
	//-----------------------------------------------*/
	if (Apci31wGetVersion(&dwDLLVer, &dwDriverVer) == FALSE){
		ErrorMessage(APCI31_SLOT_AUTO);
		return 1;
	}
	_stprintf_s(szBuf, 256, _T("GetVersion\n")
							_T("DLL    Version\t: %08lxh\n")
							_T("Driver Version\t: %08lxh"),
							dwDLLVer,
							dwDriverVer);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// aPCI-P31̎gp錾
	//-----------------------------------------------*/
	wLogSlot = APCI31_SLOT_AUTO;			/* gp޲T܂B*/
	bResult = Apci31wCreate(&wLogSlot);		/* ꍇA̎޲̘_ۯĔԍi[܂B*/
	if (bResult == FALSE){					/* ޲܂B*/
		ErrorMessage(APCI31_SLOT_AUTO);
		return 1;
	}
	_stprintf_s(szBuf, 256, _T("aPCI-P31 Created\n\n")
							_T("LogSlot: %2d"),
							wLogSlot);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// ؿ۰ذ̒l擾
	//-----------------------------------------------*/
	if (Apci31wGetResource(wLogSlot, &Ri) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	if (Apci31wGetSwitchValue(wLogSlot, &dwSwVal) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	_stprintf_s(szBuf, 256, _T("Board Name: %s\n")
							_T("IO Address: %04xh-%04xh\n")
							_T("Switch    : %04x\n"),
							szP31,
							Ri.dwIOPortBase[0],
							Ri.dwIOPortBase[0] + Ri.dwIOPortLength[0] - 1,
							dwSwVal);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// Port 1 ɔCӂްo
	//-----------------------------------------------*/
	cbDat = (BYTE)0x55;
	if (Apci31wOutPort(wLogSlot, APCI31_PORT_1, cbDat) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	_stprintf_s(szBuf, 256, _T("Port 1 փf[^o\n")
							_T("Port 1 Out Data: %02xh"),
							cbDat);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// Port 1 ްǂݍ
	//-----------------------------------------------*/
	cbDat = (BYTE)0x00;
	if (Apci31wInPort(wLogSlot, APCI31_PORT_1, &cbDat) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	_stprintf_s(szBuf, 256, _T("Port 1 f[^\n")
							_T("Port 1 In Data: %02xh"),
							cbDat);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// aPCI-P31̎gpJ
	//-----------------------------------------------*/
	if (Apci31wClose(wLogSlot) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	ResultMessage(_T("aPCI-P31 Closed"));
	/*-------------------------------------------------
	// apci31.dll ̎gpJ
	//-----------------------------------------------*/
	if (Apci31wDllClose() == FALSE){
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;
	}
	return 0;
}
/*============================================================================
// ʂ\
//==========================================================================*/
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}
/*============================================================================
// װүނ\
//==========================================================================*/
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Apci31wGetLastError(wLogSlot);
	TCHAR szBuf[256];

	switch (dwRes){
		case APCI31_ERR_SYSTEM:
			_stprintf_s(szBuf, 256, _T("System error\n\n")
									_T("Error code: %08lxh"),
									GetLastError());
			break;
		case APCI31_ERR_WRAPDLL:
			wsprintf(szBuf, _T("DLL Load error"));
			break;
		default:
			_stprintf_s(szBuf, 256, _T("aPCI-P31 error\n\n")
									_T("Error code: %08lxh"),
									dwRes);
			break;
	}
	MessageBox(NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP);
}
