/*============================================================================
//	apci31w.c
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.11 Date 1999/08/23
//
//==========================================================================*/
#include <windows.h>
#include <tchar.h>
#include "apci31w.h"	/* aPCI-P31 */

/*-------------------------------------
// (STATIC)ϐȂ
//-----------------------------------*/
static BOOL Apci31wGetDllExportFunc();
static HMODULE hDLL = NULL;

/* DLL ߰Ċ֐ڽ̊i[ϐ */
static FARPROC pApci31GetVersion = NULL;
static FARPROC pApci31Create = NULL;
static FARPROC pApci31Close = NULL;
static FARPROC pApci31GetResource = NULL;
static FARPROC pApci31InPort = NULL;
static FARPROC pApci31OutPort = NULL;
static FARPROC pApci31GetLastError = NULL;
static FARPROC pApci31GetSwitchValue = NULL;

/*============================================================================
// 	  apci31.dll۰(۰ގʹװƂ)	
// 	  
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci31wDllOpen()
{
	BOOL	Result = FALSE;
	if (hDLL == NULL){
		hDLL = (HMODULE)LoadLibrary(APCI31_DLL_NAME);
		if (hDLL != NULL){
			Result = Apci31wGetDllExportFunc();
			if (TRUE != Result)
				Apci31wDllClose();	/* DLL֐擾ɎŝDLL۰ */
		}
	}
	return Result;
}
/*============================================================================
// 	  apci31.dll۰(۰ގʹװƂ)
// 	  
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci31wDllClose()
{
	BOOL	Result = FALSE;
	if (hDLL != NULL){
		Result = FreeLibrary(hDLL);
		if (TRUE == Result)
			hDLL = NULL;
	}
	return Result;
}
/*============================================================================
// 	  aPCI-P31 DLL,޲ײްްޮݔԍ擾
// 	  pdwDllVersion		DLLްޮݔԍi[̈ւ߲
//		  pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci31wGetVersion(PDWORD pdwDllVersion, PDWORD pdwDriverVersion)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci31GetVersion)(pdwDllVersion, pdwDriverVersion);
	return Result;
}
/*============================================================================
// 	  aPCI-P31̔Cӂ޲̎gp錾
// 	  pwLogSlot	 gp޲̘_ۯĔԍi[߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci31wCreate(PWORD pwLogSlot)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci31Create)(pwLogSlot);
	return Result;
}
/*============================================================================
// 	  aPCI-P31̔Cӂ޲̎gpJ
// 	  wLogSlot ޲̘_ۯĔԍ
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci31wClose(WORD wLogSlot)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci31Close)(wLogSlot);
	return Result;
}
/*============================================================================
// 	  w޲ؿ擾
// 	  wLogSlot	ؿ擾޲̘_ۯĔԍ
//		  pResInfo	ؿi[\߲̂
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci31wGetResource(WORD wLogSlot, PAPCI31R pResInfo)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci31GetResource)(wLogSlot, pResInfo);
	return Result;
}
/*============================================================================
// 	  Cӂ߰Ăް
// 	  wLogSlot	͂޲̘_ۯĔԍ
//		  dwLogPort	͂_߰
//		  pbInValue ްi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci31wInPort(WORD wLogSlot, DWORD dwLogPort, PBYTE pbInValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci31InPort)(wLogSlot, dwLogPort, pbInValue);
	return Result;
}
/*============================================================================
// 	  Cӂ߰Ăްo
// 	  wLogSlot	o͂޲̘_ۯĔԍ
//		  dwLogPort	o͂_߰
//		  bOutValue o͂ް
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci31wOutPort(WORD wLogSlot, DWORD dwLogPort, BYTE bOutValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci31OutPort)(wLogSlot, dwLogPort, bOutValue);
	return Result;
}
/*============================================================================
// 	  aPCI-P31̴װ
// 	  wLogSlot	װ޲̘_ۯĔԍ
// ߂l װ
//==========================================================================*/
DWORD Apci31wGetLastError(WORD wLogSlot)
{
	if (NULL == hDLL)
		return APCI31_ERR_WRAPDLL;
	else
		return (*pApci31GetLastError)(wLogSlot);
}
/*============================================================================
// 	  ۰ذ̒l擾
//    wLogSlot			۰ذ̒l擾޲̘_ۯĔԍ
// 		  pdwSwitchValue	۰ذ̒li[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci31wGetSwitchValue(WORD wLogSlot, PDWORD pdwSwitchValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci31GetSwitchValue)(wLogSlot, pdwSwitchValue);
	return Result;
}
/*----------------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  TRUE
//		  s FALSE
//--------------------------------------------------------------------------*/
static BOOL Apci31wGetDllExportFunc()
{
	/* Apci31GetVersion ̱ڽ擾 */
	pApci31GetVersion = GetProcAddress(hDLL, _T("Apci31GetVersion"));
	if (pApci31GetVersion == NULL)
		return FALSE;

	/* Apci31Create ̱ڽ擾 */
	pApci31Create = GetProcAddress(hDLL, _T("Apci31Create"));
	if (pApci31Create == NULL)
		return FALSE;

	/* Apci31Close ̱ڽ擾 */
	pApci31Close = GetProcAddress(hDLL, _T("Apci31Close"));
	if (pApci31Close == NULL)
		return FALSE;

	/* Apci31GetResource ̱ڽ擾 */
	pApci31GetResource = GetProcAddress(hDLL, _T("Apci31GetResource"));
	if (pApci31GetResource == NULL)
		return FALSE;

	/* Apci31InPort ̱ڽ擾 */
	pApci31InPort = GetProcAddress(hDLL, _T("Apci31InPort"));
	if (pApci31InPort == NULL)
		return FALSE;

	/* Apci31OutPort ̱ڽ擾 */
	pApci31OutPort = GetProcAddress(hDLL, _T("Apci31OutPort"));
	if (pApci31OutPort == NULL)
		return FALSE;

	/* Apci31GetLastError ̱ڽ擾 */
	pApci31GetLastError = GetProcAddress(hDLL, _T("Apci31GetLastError"));
	if (pApci31GetLastError == NULL)
		return FALSE;

	/* Apci31GetSwitchValue ̱ڽ擾 */
	pApci31GetSwitchValue = GetProcAddress(hDLL, _T("Apci31GetSwitchValue"));
	if (pApci31GetSwitchValue == NULL)
		return FALSE;

	return TRUE;	/* SĂ DLL ߰Ċ֐ڽ擾 */
}
